#pragma once

#include <RobotAPI/interface/aron.ice>


module armarx
{
    module armem
    {
        // WIP

        module data
        {
            struct MemoryID
            {
                string memoryName = "";
                string coreSegmentName = "";
                string providerSegmentName = "";
                string entityName = "";
                long timestampMicroSeconds = -1;
                int instanceIndex = -1;
            }

            /// Ice Twin of `armarx::armem::EntityMetadata`.
            class EntityMetadata
            {
                long timeCreatedMicroSeconds;
                long timeSentMicroSeconds;
                long timeArrivedMicroSeconds;

                float confidence = 1.0;
            };
            /// Ice Twin of `armarx::armem::EntityData`.
            class EntityData
            {
                MemoryID id;
                aron::data::AronData data;

                EntityMetadata metadata;
            };
            sequence<EntityData> EntityDataSeq;


            /// Ice Twin of `armarx::armem::EntitySnapshot`.
            class EntitySnapshot
            {
                MemoryID id;
                EntityDataSeq instances;
            };
            dictionary<long, EntitySnapshot> EntityHistory;


            /// Ice Twin of `armarx::armem::Entity`.
            class Entity
            {
                MemoryID id;
                EntityHistory history;
            };
            dictionary<string, Entity> EntityDict;


            /// Ice Twin of `armarx::armem::ProviderSegment`.
            class ProviderSegment
            {
                MemoryID id;
                EntityDict entities;
            };
            dictionary<string, ProviderSegment> ProviderSegmentDict;


            /// Ice Twin of `armarx::armem::CoreSegment`.
            class CoreSegment
            {
                MemoryID id;
                // aron::type::AronType type;
                ProviderSegmentDict providerSegments;
            };
            dictionary<string, CoreSegment> CoreSegmentDict;


            /// Ice Twin of `armarx::armem::Memory`.
            class Memory
            {
                MemoryID id;
                // aron::type::AronType type;
                CoreSegmentDict coreSegments;
            };
            dictionary<string, Memory> MemoryDict;

        }

    };
};
