#include "QTreeWidgetAronDataVisitor.h"


namespace armarx::armem
{

    QTreeWidgetAronDataVisitor::QTreeWidgetAronDataVisitor(QTreeWidgetItem* root)
    {
        rootItems.push(root);
    }

    QTreeWidgetAronDataVisitor::~QTreeWidgetAronDataVisitor()
    {}

    bool QTreeWidgetAronDataVisitor::visitEnter()
    {
        if (rootItems.size() > 0)
        {
            items.push(rootItems.top());
            rootItems.pop();
        }
        else
        {
            items.push(new QTreeWidgetItem());
        }
        return true;
    }

    bool QTreeWidgetAronDataVisitor::visitExit()
    {
        QTreeWidgetItem* item = items.top();
        items.pop();
        if (items.size() > 0)
        {
            items.top()->addChild(item);
        }
        else
        {
            rootItems.push(item);
        }
        return true;
    }

    void QTreeWidgetAronDataVisitor::streamValueText(AronStringDataNavigator& n, stringstream& ss)
    {
        ss << "'" << n.getValue() << "'";
    }

    void QTreeWidgetAronDataVisitor::streamValueText(AronNDArrayDataNavigator& n, stringstream& ss)
    {
        // No useful data in n
        (void) n;
        ss << "<NdArray>";
    }


}
