#pragma once

#include <string>

#include "../../core/MemoryID.h"


namespace armarx::armem::detail
{

    /**
     * @brief Base class of memory classes on different levels.
     */
    class MemoryLevel
    {
    public:

        MemoryLevel();
        MemoryLevel(const MemoryID& id);

        virtual ~MemoryLevel();


        inline MemoryID& id()
        {
            return _id;
        }
        inline const MemoryID& id() const
        {
            return _id;
        }

        // Introspection

        /// Get a string version of `*this`' key.
        virtual std::string getKeyString() const = 0;

        /// Get a readable name of this level for messages, errors etc.
        virtual std::string getLevelName() const = 0;


    protected:

        /// The memory ID.
        MemoryID _id;

    };

}
