#include "ice_conversions.h"


namespace armarx
{

    void armem::fromIce(const data::Commit& ice, InternalCommit& commit, Time timeArrived)
    {
        commit.updates.clear();
        for (const auto& ice_update : ice.updates)
        {
            InternalEntityUpdate& update = commit.updates.emplace_back(InternalEntityUpdate());
            fromIce(ice_update, update, timeArrived);
        }
    }


    void armem::fromIce(const data::EntityUpdate& ice, InternalEntityUpdate& update, Time timeArrived)
    {
        armem::fromIce(ice, update);
        update.timeArrived = timeArrived;
    }

    void armem::toIce(data::EntityMetadata& ice, const EntityMetadata& metadata)
    {
        ice.confidence = metadata.confidence;
        toIce(ice.timeArrivedMicroSeconds, metadata.timeArrived);
        toIce(ice.timeCreatedMicroSeconds, metadata.timeCreated);
        toIce(ice.timeSentMicroSeconds, metadata.timeSent);
    }
    void armem::fromIce(const data::EntityMetadata& ice, EntityMetadata& metadata)
    {
        metadata.confidence = ice.confidence;
        fromIce(ice.timeArrivedMicroSeconds, metadata.timeArrived);
        fromIce(ice.timeCreatedMicroSeconds, metadata.timeCreated);
        fromIce(ice.timeSentMicroSeconds, metadata.timeSent);
    }

    void armem::toIce(data::EntityData& ice, const EntityData& data)
    {
        toIce(ice.id, data.id());

        ice.data = data.data;
        toIce(ice.metadata, data.metadata);
    }
    void armem::fromIce(const data::EntityData& ice, EntityData& data)
    {
        fromIce(ice.id, data.id());

        data.setData(ice.data);
        fromIce(ice.metadata, data.metadata);
    }


    void armem::toIce(data::EntitySnapshot& ice, const EntitySnapshot& snapshot)
    {
        toIce(ice.id, snapshot.id());

        toIce(ice.instances, snapshot.instances);
    }
    void armem::fromIce(const data::EntitySnapshot& ice, EntitySnapshot& snapshot)
    {
        fromIce(ice.id, snapshot.id());
        fromIce(ice.instances, snapshot.instances);
    }

    void armem::toIce(data::Entity& ice, const Entity& entity)
    {
        toIce(ice.id, entity.id());

        toIce(ice.history, entity.history);
    }
    void armem::fromIce(const data::Entity& ice, Entity& entity)
    {
        fromIce(ice.id, entity.id());

        fromIce(ice.history, entity.history);
    }


    void armem::toIce(data::ProviderSegment& ice, const ProviderSegment& providerSegment)
    {
        toIce(ice.id, providerSegment.id());

        toIce(ice.entities, providerSegment.entities);
    }
    void armem::fromIce(const data::ProviderSegment& ice, ProviderSegment& providerSegment)
    {
        fromIce(ice.id, providerSegment.id());

        fromIce(ice.entities, providerSegment.entities);
    }

    void armem::toIce(data::CoreSegment& ice, const CoreSegment& coreSegment)
    {
        toIce(ice.id, coreSegment.id());

        toIce(ice.providerSegments, coreSegment.providerSegments);
    }
    void armem::fromIce(const data::CoreSegment& ice, CoreSegment& coreSegment)
    {
        fromIce(ice.id, coreSegment.id());

        fromIce(ice.providerSegments, coreSegment.providerSegments);
    }

    void armem::toIce(data::Memory& ice, const Memory& memory)
    {
        toIce(ice.id, memory.id());

        toIce(ice.coreSegments, memory.coreSegments);
    }
    void armem::fromIce(const data::Memory& ice, Memory& memory)
    {
        fromIce(ice.id, memory.id());

        fromIce(ice.coreSegments, memory.coreSegments);
    }

}


