#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"
#include "CoreSegmentQueryProcessor.h"



namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor : public BaseQueryProcessor<Memory, query::MemoryQuery>
    {
    public:

        using BaseQueryProcessor::process;

        void process(Memory& result, const query::MemoryQuery& query, const Memory& memory) const;

        void process(Memory& result, const query::memory::All& query, const Memory& memory) const;
        void process(Memory& result, const query::memory::Single& query, const Memory& memory) const;
        void process(Memory& result, const query::memory::Regex& query, const Memory& memory) const;


        data::MemoryPtr processToIce(const query::MemoryQuery& query, const Memory& memory) const;
        data::MemoryPtr processToIce(const query::MemoryQuerySeq& query, const Memory& memory) const;


    private:

        CoreSegmentQueryProcessor coreSegmentProcessor;

    };

}
